Overview

The dynamic array is used to replace array formula. Any formula that has the potential to return multiple results can be referred to as a dynamic array formula. Formulas that are currently returning multiple results, and are successfully spilling, can be referred to as spilled array formulas.

In the following example, the value from C3 spills over to the adjacent cells. The value in C9 however will display the #SPILL! error as there is an existing value in the range preventing the spill.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

Users can enable dynamic array functions in one of two ways:

// 1st way:
var workbook = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 3, allowDynamicArray: true});
// 2rd way:
var workbook = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
workbook.options.allowDynamicArray = true;

Spill means that a formula has returned multiple values and those values ‘spill’ into the neighboring cells.

Dynamic Array has seven Functions:

  • FILTER function: Filters a range of data based on criteria you defined.
  • RANDARRAY function: Returns an array of random numbers.
  • SEQUENCE function: Generates a list of sequential numbers in an array, such as 1, 2, 3, 4.
  • SORT function: Sorts the contents of a range or array.
  • SORTBY function: Sorts the contents of a range or array based on the values in a corresponding range or array.
  • UNIQUE function: Returns a list of unique values in a list or range.
  • The implicit intersection operator @: Returns a single value using logic known as implicit intersection.

The Spill Range Operator # can reference the entire spill range:

  • When you're dealing with spilled array functions, it's possible to reference the entire spill range by placing the spilled range operator (#) after the range.

#SPILL errors are returned when a formula returns multiple values that cannot display the results in the spreadsheet for any of the following reasons:

  1. Spill range for a spilled array formula isn't blank.
  2. Unable to determine the size of the spilled array because it's volatile, and resizes between calculation passes.
  3. The spilled array formula you're attempting to enter will extend beyond the worksheet's range.
  4. Spilled array formulas in tables.
  5. The spilled array formula you're attempting to enter has caused to run out of memory.
  6. Spilled array formulas spill into merged cells.
  7. The formula cannot recognize or cannot reconcile.

#CALC! errors are retuned when any of the following results are true:

  1. Calculate an array within an array.
  2. Arrays can only contain numbers, strings, errors, Booleans, or linked data types. Range references aren't supported.
  3. Return an empty set.
  4. Calculation engine encounters an unspecified calculation error with an array.
Users can enable dynamic array functions in one of two ways: Spill means that a formula has returned multiple values and those values ‘spill’ into the neighboring cells. Dynamic Array has seven Functions: FILTER function: Filters a range of data based on criteria you defined. RANDARRAY function: Returns an array of random numbers. SEQUENCE function: Generates a list of sequential numbers in an array, such as 1, 2, 3, 4. SORT function: Sorts the contents of a range or array. SORTBY function: Sorts the contents of a range or array based on the values in a corresponding range or array. UNIQUE function: Returns a list of unique values in a list or range. The implicit intersection operator @: Returns a single value using logic known as implicit intersection. The Spill Range Operator # can reference the entire spill range: When you're dealing with spilled array functions, it's possible to reference the entire spill range by placing the spilled range operator (#) after the range. #SPILL errors are returned when a formula returns multiple values that cannot display the results in the spreadsheet for any of the following reasons: Spill range for a spilled array formula isn't blank. Unable to determine the size of the spilled array because it's volatile, and resizes between calculation passes. The spilled array formula you're attempting to enter will extend beyond the worksheet's range. Spilled array formulas in tables. The spilled array formula you're attempting to enter has caused to run out of memory. Spilled array formulas spill into merged cells. The formula cannot recognize or cannot reconcile. #CALC! errors are retuned when any of the following results are true: Calculate an array within an array. Arrays can only contain numbers, strings, errors, Booleans, or linked data types. Range references aren't supported. Return an empty set. Calculation engine encounters an unspecified calculation error with an array.
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById("ss")); initSpread(spread); }; function initSpread(spread) { spread.options.allowDynamicArray = true; var sheet = spread.getActiveSheet(); spread.suspendPaint(); spread.suspendCalcService(); sheet.setValue(1, 2, "=SEQUENCE(3,3)"); sheet.setFormula(2, 2, 'SEQUENCE(3,3)'); sheet.setValue(7, 2, "=SEQUENCE(3,3)"); sheet.setFormula(8, 2, 'SEQUENCE(3,3)'); sheet.setValue(9, 3, 3); bindEvent(spread, sheet); spread.resumeCalcService(); spread.resumePaint(); } function bindEvent (spread, sheet) { _getElementById("allowDynamicArray").addEventListener('change', function () { spread.options.allowDynamicArray = this.checked; sheet && sheet.recalcAll(true); }); } function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <input style="width: 20px;float: left;" type="checkbox" id="allowDynamicArray" checked="checked"/> <label for="allowDynamicArray">Allow DynamicArray</label> </div> </div> </div></body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } input { margin-bottom: 5px; padding: 2px 4px; width: 100%; box-sizing: border-box; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Users can enable dynamic array functions in one of two ways:
Spill means that a formula has returned multiple values and those values ‘spill’ into the neighboring cells.
Dynamic Array has seven Functions:
FILTER function: Filters a range of data based on criteria you defined.
RANDARRAY function: Returns an array of random numbers.
SEQUENCE function: Generates a list of sequential numbers in an array, such as 1, 2, 3, 4.
SORT function: Sorts the contents of a range or array.
SORTBY function: Sorts the contents of a range or array based on the values in a corresponding range or array.
UNIQUE function: Returns a list of unique values in a list or range.
The implicit intersection operator @: Returns a single value using logic known as implicit intersection.
The Spill Range Operator # can reference the entire spill range:
When you're dealing with spilled array functions, it's possible to reference the entire spill range by placing the spilled range operator (#) after the range.
#SPILL errors are returned when a formula returns multiple values that cannot display the results in the spreadsheet for any of the following reasons:
Spill range for a spilled array formula isn't blank.
Unable to determine the size of the spilled array because it's volatile, and resizes between calculation passes.
The spilled array formula you're attempting to enter will extend beyond the worksheet's range.
Spilled array formulas in tables.
The spilled array formula you're attempting to enter has caused to run out of memory.
Spilled array formulas spill into merged cells.
The formula cannot recognize or cannot reconcile.
#CALC! errors are retuned when any of the following results are true:
Calculate an array within an array.
Arrays can only contain numbers, strings, errors, Booleans, or linked data types. Range references aren't supported.
Return an empty set.
Calculation engine encounters an unspecified calculation error with an array.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export function AppFunc() {
let spread = null;
let initSpread = function (value) {
spread = value;
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.setValue(1, 2, "=SEQUENCE(3,3)");
sheet.setFormula(2, 2, 'SEQUENCE(3,3)');
sheet.setValue(7, 2, "=SEQUENCE(3,3)");
sheet.setFormula(8, 2, 'SEQUENCE(3,3)');
sheet.setValue(9, 3, 3);
spread.resumeCalcService();
spread.resumePaint();
}
let setAllowDynamicArray = function (e) {
var sheet = spread.getActiveSheet();
spread.options.allowDynamicArray = e.target.checked;
sheet && sheet.recalcAll(true);
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel setAllowDynamicArray={(e) => { setAllowDynamicArray(e) }} />
</div>);
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="options-container">
<div class="option-row">
<input style={{ width: "20px", float: "left" }} type="checkbox" id="allowDynamicArray" defaultChecked="checked" onChange={(e) => { this.props.setAllowDynamicArray(e) }} />
<label htmlFor="allowDynamicArray">Allow DynamicArray</label>
</div>
</div>
)
}
}
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel setAllowDynamicArray={(e) => { this.setAllowDynamicArray(e) }} />
</div>;
}
initSpread(spread) {
this.spread = spread;
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.setValue(1, 2, "=SEQUENCE(3,3)");
sheet.setFormula(2, 2, 'SEQUENCE(3,3)');
sheet.setValue(7, 2, "=SEQUENCE(3,3)");
sheet.setFormula(8, 2, 'SEQUENCE(3,3)');
sheet.setValue(9, 3, 3);
spread.resumeCalcService();
spread.resumePaint();
}
setAllowDynamicArray(e) {
var spread = this.spread, sheet = spread.getActiveSheet();
spread.options.allowDynamicArray = e.target.checked;
sheet && sheet.recalcAll(true);
}
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="options-container">
<div class="option-row">
<input style={{ width: "20px", float: "left" }} type="checkbox" id="allowDynamicArray" defaultChecked="checked" onChange={(e) => { this.props.setAllowDynamicArray(e) }} />
<label htmlFor="allowDynamicArray">Allow DynamicArray</label>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Users can enable dynamic array functions in one of two ways:
Spill means that a formula has returned multiple values and those values ‘spill’ into the neighboring cells.
Dynamic Array has seven Functions:
FILTER function: Filters a range of data based on criteria you defined.
RANDARRAY function: Returns an array of random numbers.
SEQUENCE function: Generates a list of sequential numbers in an array, such as 1, 2, 3, 4.
SORT function: Sorts the contents of a range or array.
SORTBY function: Sorts the contents of a range or array based on the values in a corresponding range or array.
UNIQUE function: Returns a list of unique values in a list or range.
The implicit intersection operator @: Returns a single value using logic known as implicit intersection.
The Spill Range Operator # can reference the entire spill range:
When you're dealing with spilled array functions, it's possible to reference the entire spill range by placing the spilled range operator (#) after the range.
#SPILL errors are returned when a formula returns multiple values that cannot display the results in the spreadsheet for any of the following reasons:
Spill range for a spilled array formula isn't blank.
Unable to determine the size of the spilled array because it's volatile, and resizes between calculation passes.
The spilled array formula you're attempting to enter will extend beyond the worksheet's range.
Spilled array formulas in tables.
The spilled array formula you're attempting to enter has caused to run out of memory.
Spilled array formulas spill into merged cells.
The formula cannot recognize or cannot reconcile.
#CALC! errors are retuned when any of the following results are true:
Calculate an array within an array.
Arrays can only contain numbers, strings, errors, Booleans, or linked data types. Range references aren't supported.
Return an empty set.
Calculation engine encounters an unspecified calculation error with an array.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.options.allowDynamicArray = true;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.setValue(1, 2, "=SEQUENCE(3,3)");
sheet.setFormula(2, 2, 'SEQUENCE(3,3)');
sheet.setValue(7, 2, "=SEQUENCE(3,3)");
sheet.setFormula(8, 2, 'SEQUENCE(3,3)');
sheet.setValue(9, 3, 3);
spread.resumeCalcService();
spread.resumePaint();
}
setAllowDynamicArray($event: any) {
let spread = this.spread, sheet = spread.getActiveSheet();
spread.options.allowDynamicArray = $event.target.checked;
sheet && sheet.recalcAll(true);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<input style="width: 20px;float: left;" type="checkbox" id="allowDynamicArray" checked="checked" (change)="setAllowDynamicArray($event)" />
<label for="allowDynamicArray">Allow DynamicArray</label>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Users can enable dynamic array functions in one of two ways:
Spill means that a formula has returned multiple values and those values ‘spill’ into the neighboring cells.
Dynamic Array has seven Functions:
FILTER function: Filters a range of data based on criteria you defined.
RANDARRAY function: Returns an array of random numbers.
SEQUENCE function: Generates a list of sequential numbers in an array, such as 1, 2, 3, 4.
SORT function: Sorts the contents of a range or array.
SORTBY function: Sorts the contents of a range or array based on the values in a corresponding range or array.
UNIQUE function: Returns a list of unique values in a list or range.
The implicit intersection operator @: Returns a single value using logic known as implicit intersection.
The Spill Range Operator # can reference the entire spill range:
When you're dealing with spilled array functions, it's possible to reference the entire spill range by placing the spilled range operator (#) after the range.
#SPILL errors are returned when a formula returns multiple values that cannot display the results in the spreadsheet for any of the following reasons:
Spill range for a spilled array formula isn't blank.
Unable to determine the size of the spilled array because it's volatile, and resizes between calculation passes.
The spilled array formula you're attempting to enter will extend beyond the worksheet's range.
Spilled array formulas in tables.
The spilled array formula you're attempting to enter has caused to run out of memory.
Spilled array formulas spill into merged cells.
The formula cannot recognize or cannot reconcile.
#CALC! errors are retuned when any of the following results are true:
Calculate an array within an array.
Arrays can only contain numbers, strings, errors, Booleans, or linked data types. Range references aren't supported.
Return an empty set.
Calculation engine encounters an unspecified calculation error with an array.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<input style="width: 20px;float: left;" type="checkbox" id="allowDynamicArray" checked="checked" @change="setAllowDynamicArray($event)"/>
<label for="allowDynamicArray">Allow DynamicArray</label>
</div>
</div>
</div>
</template>
<script setup>
import { ref } from 'vue';
const spreadRef = ref(null);
function initSpread (spread) {
spreadRef.value = spread;
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.setValue(1, 2, "=SEQUENCE(3,3)");
sheet.setFormula(2, 2, 'SEQUENCE(3,3)');
sheet.setValue(7, 2, "=SEQUENCE(3,3)");
sheet.setFormula(8, 2, 'SEQUENCE(3,3)');
sheet.setValue(9, 3, 3);
spread.resumeCalcService();
spread.resumePaint();
}
function setAllowDynamicArray (e) {
var spread = spreadRef.value, sheet = spread.getActiveSheet();
spread.options.allowDynamicArray = e.target.checked;
sheet && sheet.recalcAll(true);
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);